<HTML>
<HEAD>
   <TITLE>Anna Goy - Tecnologie Web: approcci avanzati</TITLE>
   <META HTTP-EQUIV="CONTENT-TYPE" CONTENT="TEXT/HTML; CHARSET=utf-8">
   <LINK REL="STYLESHEET" TYPE="TEXT/CSS" HREF="anna.css">
</HEAD>
<BODY>

<!-- striscia in alto -->
<TABLE BORDER="0" CELLPADDING="1" CELLSPACING="0" WIDTH="100%" BGCOLOR="#003399">
<TR>
<TD VALIGN="MIDDLE">
 <P class="small-white">
   Anna Goy - Dip. di Informatica - Universit&agrave; di Torino - Corso Svizzera 185 - 10149 Torino (Italia) - annamaria.goy[-at-]unito.it
 </P>
</TD>
</TR>
</TABLE>

<P class="blue">
  Tecnologie Web: approcci avanzati
  <br />
  <strong>PHP e dintorni</strong>
</P>

<HR WIDTH="100%" />

<P><strong>Prove array e cicli (for)</strong></P>

<P>
<?php
    $personaggi = array("pippo", "pluto", "minni");
	$lungh = count($personaggi);
	print "Ci sono $lungh personaggi <br/>";
	$personaggi[] = "basettoni";
	$lungh = count($personaggi);
	print "Ho aggiunto <em>$personaggi[3]</em>, ora ci sono $lungh personaggi, che sono: <br/>";
	print_r($personaggi);
?>
<br />
<?php
	unset($personaggi[1]);
	$lungh = count($personaggi);
	print "Ho cancellato il secondo personaggio (<em>[1] => pluto</em>), ora ci sono $lungh personaggi, che sono: <br/>";
	print_r($personaggi);
?>
<br/>
... occhio agli indici!!
</P>
<P class="red">Bruttino però... <br /> Proviamo a fare un po' meglio</P>

<P>Lettura con il for:</P>
<UL>
<?php
    for ($i = 0; $i < $lungh; $i++) {
?>
		<li><?= $personaggi[$i] ?></li>
<?php
	}
?>
</UL>

<P class="red">Visto cosa succede ad aver generato dei "buchi" nell'array con la funzione <em>unset</em>?!?</P>

<P>Lettura con il foreach:</P>
<UL>
<?php
    foreach ($personaggi as $pers) {
?>
		<li><?= $pers ?></li>
<?php
	}
?>
</UL>

<P>Tentativo di modifica e successiva ri-lettura entrambe con il foreach :-(</P>
<?php
	foreach ($personaggi as $pers) {
		$pers = "hasta siempre ".$pers;
	}
?>
<UL>
<?php
	foreach ($personaggi as $pers) {
?>
		<li><?= $pers ?></li>
<?php
	}
?>
</UL>

<P>Modifica con il for + successiva ri-lettura con il foreach :-)</P>
<?php
    for ($i = 0; $i < $lungh; $i++) {
		$personaggi[$i] = "hasta siempre ".$personaggi[$i];
	}
?>
<UL>
<?php
	foreach ($personaggi as $pers) {
?>
		<li><?= $pers ?></li>
<?php
	}
?>
</UL>

<P><strong>*** ARRAY ASSOCIATIVI ***</strong></P>

<?php
    $personaggio = array("nome" => "Paolino",
					 "cognome " => "Paperino",
					 "residenza" => "Paperopoli",
					 "nazionalita" => "americana"
			   );  
	print_r($personaggio);

	print "</br> Aggiungo Qui, Quo, Qua <br/>";	
	$personaggio["nipoti"] = "Qui, Quo, Qua";
	print_r($personaggio);
	
	print "</br> Elimino la nazionalità (dopo aver controllato che la chiave esista) <br/>";
	if (array_key_exists("nazionalita", $personaggio)) {
		unset($personaggio["nazionalita"]);
	}
	print_r($personaggio);
?>
</P>
<P class="red">E' sempre bruttino... <br /> Proviamo con un ciclo (foreach)</P>

<UL>
<?php
    foreach ($personaggio as $propr => $val) {
?>
		<li><?= $propr ?> = <?= $val ?></li>
<?php
	}
?>
</UL>

<P class="red"><strong>Qual è la morale della favola?</strong></P>

</BODY>
</HTML>